unit ssdemo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SScript, HyperStr, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  P:AnsiString;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Modified:=True;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Memo1.Modified then begin
    P:=ParseStr(Memo1.Text);
    Memo1.Modified:=False;
  end;
  EvalStr(P);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  R:AnsiString;
  I,J,K:Integer;
begin
  Setlength(R,0);
  if InputQuery('Goto Line', 'Enter +/- line number',R) then begin
    if IsFloat(R) then begin
      I:=StrToInt(R);
      Memo1.SelLength:=0;
      if I>0 then Dec(I)
      else if I<0 then begin
        I:=-I;
        J:=0;
        R:=Memo1.Text;
        K:=Length(R);
        while I>0 do begin
          K:=J+1;
          J:=ScanC(R,#13,K);
          if J=0 then begin
            K:=Length(R);
            break;
          end;
          if (J-K)>1 then begin
            K:=ScanLU(R,#33,#255,K);
            if (K>0) and (K<J) and (not (R[K] in ['!','$'])) then Dec(I);
          end;
        end;
        I:=Memo1.Perform(EM_LINEFROMCHAR,K,0);
      end;
      with Memo1 do begin
        SetFocus;
        SelStart:=Perform(EM_LINEINDEX,I,0);
        Perform(EM_SCROLLCARET,0,0);
      end;
    end;
  end;
end;

end.
